<script>
import { IonIcon } from "@ionic/vue";
import { addIcons } from 'ionicons';
import { arrowForwardOutline } from 'ionicons/icons';
import DialogModal from "../Components/DialogModal.vue";
import {ref, watch} from "vue";
import {Link} from "@inertiajs/vue3";
import Register from "../Pages/Modals/Register.vue";

export default {
  components: {Register, IonIcon, DialogModal, Link},

  name: "Layout",

  props: {
    session: Object,
    auth: {
      type: Object,
      required: true,
    },
  },

  setup(props) {
    const authModalIsOpen = ref(false);
    const authModalKey = ref(new Date().getTime().toString());
    const authModalMessage = ref('');
    const authModalDescription = ref('');

    watch(
      () => props.session,
      (session) => {
        authModalIsOpen.value = !!session?.requireAuth;
        authModalKey.value = new Date().getTime().toString()
        authModalMessage.value = session?.requireAuth?.title;
        authModalDescription.value = session?.requireAuth?.description;
      },
    );

    addIcons({
      'arrow-forward-outline': arrowForwardOutline,
    });

    window.counter = function() {
      // this refers to the html element with the data-scroll-showCallback tag
      const span = this.querySelector('span');
      const current = parseInt(span.textContent);

      span.textContent = current + 1;
    };

    return {
      authModalIsOpen,
      authModalKey,
      authModalMessage,
      authModalDescription,
    };
  },
}
</script>

<template>
  <div id="wrapper">
      <section id="welcome">
          <div id="logo-with-menu">
              <div class="container">
                  <div class="topline">
                      <div class="logo_top">
                        <Link href="/" preserve-state>
                          <img src="../../img/main-logo.png" alt="">
                        </Link>

                        <a class="menu-triger" href="#">
                          <span>
                            <span></span>
                            <span></span>
                            <span></span>
                          </span>
                        </a>
                        <div class="menu_top">
                          <ul>
                            <li><a href="#advantages" class="scroll-to">О профессиии</a></li>
                            <li><a href="#what" class="scroll-to">Что Вас ждет</a></li>
                            <li><a href="#programma" class="scroll-to">Программа</a></li>
                          </ul>
                        </div>
                      </div>
                    <div class="lk_top d-none d-lg-block">
                      <ul>
                        <li>
                          <Link href="/lessons" class="link" preserve-state>Моё обучение</Link>
                        </li>
                        <li>
                          <Link href="/profile" class="lk" preserve-state>
                            <img src="../../img/f1.png" alt="">
                          </Link>
                        </li>
                        <template v-if="auth.user">
                          <li>
                            {{ auth.user.name }}
                          </li>
                          <li>
                            <Link class="link" href="/logout" method="post" as="button" preserve-state>
                              Выйти
                            </Link>
                          </li>
                        </template>
                      </ul>
                    </div>
                  </div>
              </div>
          </div>
      </section>
    <slot />
  </div>
  <div id="footer">
    <div class="container">
      <div class="foot">
        <div class="foot_logo">
          <img src="../../img/main-logo-foot.png" alt="">
        </div>
        <div class="footer_menu">
          <ul>
            <li><a href="#advantages" class="scroll-to">О профессиии</a></li>
            <li><a href="#what" class="scroll-to">Что Вас ждет</a></li>
            <li><a href="#programma" class="scroll-to">Программа</a></li>
          </ul>
        </div>
      </div>
    </div>
  </div>

  <DialogModal v-if="authModalIsOpen" v-model="authModalIsOpen" :key="authModalKey" :title="authModalMessage">
    <template #content>
      {{ authModalDescription }}
    </template>

    <template #actions>
      <Link href="/register" class="btn btn-primary">Регистрация</Link>
      <Link href="/login" class="btn btn-primary">Вход</Link>
    </template>
  </DialogModal>
</template>
